#include "types.h"
#include "console.h"
#include "string.h"
#include "io.h"


void __stack_chk_fail(void)
{
	return;
}

int caos_strlen(const char *s)
{
		int i = 0;
		while (s[i] != '\0')
				i++;

		return i;
}


void init_video(void)
{
		VRAM = (unsigned char *)0xb8000;
		cur_offset = 80;
		move_cursor(cur_offset);
		cur_x = cur_offset % 80;
		cur_y = cur_offset / 80;
}
		


void caos_putchar(unsigned char A_byteChar)
{
		*(VRAM + (cur_offset*2) ) = A_byteChar;
		cur_offset++;
		move_cursor(cur_offset);
}


void PrintString(char *A_szString, int A_iSize)
{
}


void move_cursor(unsigned int A_dwNewCursorOffset)
{
		unsigned int dwTemp;

		/* set cursor to new position */
		cur_offset = A_dwNewCursorOffset;
		cur_x = A_dwNewCursorOffset % 80;
		cur_y = A_dwNewCursorOffset / 80;

		/* port 0x3d4 :  */
		dwTemp = (unsigned int)(cur_offset >> 8);
		outb((WORD)0x3d4, 0x0e);
		outb((WORD)0x3d5, dwTemp);

		dwTemp = (unsigned int)(cur_offset & (unsigned int)0xff);
		outb((WORD)0x3d4, 0x0f);
		outb((WORD)0x3d5, dwTemp);

}

						

char sz[64];

int caos_printf(const char *format, ...)
{
		va_list ap;
		int i = 0;

		va_start(ap, format);
		caos_vsprintf(sz, format, ap);
		va_end(ap);

		/*PrintString(sz, caos_strlen(sz));*/
		while (sz[i] != '\0') {
				if (sz[i] == 0xa) {
						move_cursor( ((int)(cur_offset/80) + 1)*80 );
						i++;
						continue;
				}
				caos_putchar(sz[i++]);
		}

		return i;
}


int caos_strcat(char *A_szDest, char *A_szSrc)
{
		char *p = A_szSrc;
		while (*A_szSrc != '\0')
				*A_szDest++ = *A_szSrc++;
		return A_szSrc-p;
}

void caos_vsprintf(char *A_szString, const char *A_szFormat, va_list A_pAp)
{
		int temp;
		

		while (*A_szFormat != '\0') {
				if (*A_szFormat == '%' && ( *(A_szFormat+1) == 'd' || *(A_szFormat+1) == 'x' )) {
						temp = va_arg(A_pAp, int);
						temp = print_dword(A_szString, temp, *(A_szFormat+1));
						A_szString += temp;
						A_szFormat += 2;
				} else if (*A_szFormat == '%' && *(A_szFormat+1) == 's') {
						temp = caos_strcat(A_szString, va_arg(A_pAp, char *));
						A_szString += temp;
						A_szFormat += 2;
				/*} else if (*A_szFormat == 0xa) {
						move_cursor( (int)( (int)(cur_offset/80) + 1)*80);
						A_szFormat += 1;*/
				} else {
						*A_szString++ = *A_szFormat++;
				}
		}
		*A_szString = '\0';

}


int print_dword(char *A_szBuffer, int a, char flag)
{
		unsigned char *p;
		unsigned char v[10];
		int i = 0;
		int count = 0;
		
		if (flag == 'd') {
				/* print signed integer */
				if (a & 0x80000000) {
						/* print minus */
						*A_szBuffer = '-';
						count++;
						a = -a;
				}
				
				while (a > 0) {
						v[i++] = a % 10;
						a /= 10;
				}

				/*while (v[--i] == 0)
						continue;*/
						
				for (--i; i >= 0; i--) {
						*A_szBuffer++ = v[i]+0x30;
						count++;
				}
				
		} else if (flag == 'x') {
				/* print hexa decimal */
				p = (char *)&a;
				for (i = sizeof(int); i > 0; i--) {
						if (p[i-1] == 0x0)
								continue;
						count++;
						if ( (p[i-1] >> 4) <= 9)
								*A_szBuffer++ = (p[i-1] >> 4) + 0x30;
						else 
								*A_szBuffer++ = (p[i-1] >> 4) + 0x37;

						count++;
						if ( (p[i-1] & 0x0f) <= 9)
								*A_szBuffer++ = (p[i-1] & 0x0f) + 0x30;
						else 
								*A_szBuffer++ = (p[i-1] & 0x0f) + 0x37;
				}
		} else {
				/* flag error */
		}
		return count;
}


